package com.rthoni.stssaguenay.business;

import com.luticate.utils.business.LuPromise;
import com.luticate.utils.dbo.LuDataAccessConfigDbo;
import com.rthoni.stssaguenay.dataaccess.RoutesDataAccess;
import com.rthoni.stssaguenay.dbo.RoutesDbo;

import java.util.List;
import java.util.Vector;

/**
 * Created by robin on 9/30/16.
 */

public class RoutesBusiness {

    private static List<RoutesDbo> _routesDbos = null;

    public static LuPromise<List<RoutesDbo>> getAll(LuDataAccessConfigDbo config)
    {
        final LuPromise<List<RoutesDbo>> promise = new LuPromise<>();
        if (_routesDbos == null) {
            RoutesDataAccess.getAll(config).then(new LuPromise.LuConsumer<List<RoutesDbo>>() {
                @Override
                public void execute(List<RoutesDbo> data) {
                    _routesDbos = data;
                    promise.resolve(data);
                }
            }, new LuPromise.LuConsumer<LuPromise.LuPromiseError>() {
                @Override
                public void execute(LuPromise.LuPromiseError data) {
                    promise.reject(data);
                }
            });
        }
        else {
            promise.resolve(_routesDbos);
        }
        return promise;
    }

    public static List<RoutesDbo> getRoutesDbos(List<RoutesDbo> routesDbos, List<String> routes)
    {
        List<RoutesDbo> filteredRoutes = new Vector<>();

        for (RoutesDbo routeDbo : routesDbos) {//TODO invert loops and sort Routes
            for (String route : routes) {
                if (routeDbo.getId().equals(route)) {
                    filteredRoutes.add(routeDbo);
                }
            }
        }

        return filteredRoutes;
    }
}
