package com.rthoni.stssaguenay.dataaccess;

import com.luticate.utils.business.LuPromise;
import com.luticate.utils.dataaccess.LuDataAccess;
import com.luticate.utils.dbo.LuDataAccessConfigDbo;
import com.rthoni.stssaguenay.dbo.UserFavouriteStopsDbo;
import com.rthoni.stssaguenay.dbo.RoutesDbo;
import com.rthoni.stssaguenay.dbo.SchedulesDbo;

import org.joda.time.LocalDateTime;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.HashMap;
import java.util.List;

/**
 * Created by robin on 10/1/16.
 */

public class SchedulesDataAccess extends LuDataAccess {

    public static LuPromise<List<SchedulesDbo>> getMultiple(LuDataAccessConfigDbo config, List<UserFavouriteStopsDbo> favouriteStopDbos, LocalDateTime date, int count)
    {
        HashMap<String, String> map = new HashMap<>();
        map.put("count", Integer.toString(count));
        map.put("date", JSONObject.quote(date.toString("y-M-d HH:mm:ss")));

        JSONArray stops = new JSONArray();
        for (UserFavouriteStopsDbo dbo : favouriteStopDbos) {
            for (RoutesDbo routesDbo : dbo.getRoutes()) {
                JSONObject obj = new JSONObject();
                try {
                    obj.put("stopId", dbo.getStop().getId());
                    obj.put("routeId", routesDbo.getId());
                } catch (JSONException e) {
                    e.printStackTrace();
                }
                stops.put(obj);
            }
        }
        map.put("stops", stops.toString());

        return post(config, SchedulesDbo.SchedulesDboArray.class, "schedules/multiple", map).map(new LuPromise.LuConverter<SchedulesDbo.SchedulesDboArray, List<SchedulesDbo>>() {
            @Override
            public List<SchedulesDbo> convert(SchedulesDbo.SchedulesDboArray data) {
                return data.getData();
            }
        });
    }
}
